/*
 * Note: this file originally auto-generated by mib2c using
 *       version $ of $ 
 *
 * $Id:$
 */
/* standard Net-SNMP includes */
#include <net-snmp/net-snmp-config.h>
#include <net-snmp/net-snmp-features.h>
#include <net-snmp/net-snmp-includes.h>
#include <net-snmp/agent/net-snmp-agent-includes.h>
/* include our parent header */
#include "dot1dBasePortTable.h"

#include <net/if.h>

#include "wrsSnmp.h"
#include "snmp_shmem.h"

#include "dot1dBasePortTable_data_access.h"

/** @ingroup interface
 * @addtogroup data_access data_access: Routines to access data
 *
 * These routines are used to locate the data used to satisfy
 * requests.
 * 
 * @{
 */
/**********************************************************************
 **********************************************************************
 ***
 *** Table dot1dBasePortTable
 ***
 **********************************************************************
 **********************************************************************/
/*
 * BRIDGE-MIB::dot1dBasePortTable is subid 4 of dot1dBase.
 * Its status is Current.
 * OID: .1.3.6.1.2.1.17.1.4, length: 9
*/

/**
 * initialization for dot1dBasePortTable data access
 *
 * This function is called during startup to allow you to
 * allocate any resources you need for the data table.
 *
 * @param dot1dBasePortTable_reg
 *        Pointer to dot1dBasePortTable_registration
 *
 * @retval MFD_SUCCESS : success.
 * @retval MFD_ERROR   : unrecoverable error.
 */
int
dot1dBasePortTable_init_data(dot1dBasePortTable_registration * dot1dBasePortTable_reg)
{
    DEBUGMSGTL(("verbose:dot1dBasePortTable:dot1dBasePortTable_init_data","called\n"));

    /*
     * TODO:303:o: Initialize dot1dBasePortTable data.
     */
    /*
    ***************************************************
    ***             START EXAMPLE CODE              ***
    ***---------------------------------------------***/
    /*
     * if you are the sole writer for the file, you could
     * open it here. However, as stated earlier, we are assuming
     * the worst case, which in this case means that the file is
     * written to by someone else, and might not even exist when
     * we start up. So we can't do anything here.
     */
    /*
    ***---------------------------------------------***
    ***              END  EXAMPLE CODE              ***
    ***************************************************/

    return MFD_SUCCESS;
} /* dot1dBasePortTable_init_data */

/**
 * container overview
 *
 */

/**
 * container initialization
 *
 * @param container_ptr_ptr A pointer to a container pointer. If you
 *        create a custom container, use this parameter to return it
 *        to the MFD helper. If set to NULL, the MFD helper will
 *        allocate a container for you.
 *
 *  This function is called at startup to allow you to customize certain
 *  aspects of the access method. For the most part, it is for advanced
 *  users. The default code should suffice for most cases. If no custom
 *  container is allocated, the MFD code will create one for your.
 *
 * @remark
 *  This would also be a good place to do any initialization needed
 *  for you data source. For example, opening a connection to another
 *  process that will supply the data, opening a database, etc.
 */
void
dot1dBasePortTable_container_init(netsnmp_container **container_ptr_ptr)
{
    DEBUGMSGTL(("verbose:dot1dBasePortTable:dot1dBasePortTable_container_init","called\n"));
    
    if (NULL == container_ptr_ptr) {
        snmp_log(LOG_ERR,"bad container param to dot1dBasePortTable_container_init\n");
        return;
    }

    /*
     * For advanced users, you can use a custom container. If you
     * do not create one, one will be created for you.
     */
    *container_ptr_ptr = NULL;

} /* dot1dBasePortTable_container_init */

/**
 * container shutdown
 *
 * @param container_ptr A pointer to the container.
 *
 *  This function is called at shutdown to allow you to customize certain
 *  aspects of the access method. For the most part, it is for advanced
 *  users. The default code should suffice for most cases.
 *
 *  This function is called before dot1dBasePortTable_container_free().
 *
 * @remark
 *  This would also be a good place to do any cleanup needed
 *  for you data source. For example, closing a connection to another
 *  process that supplied the data, closing a database, etc.
 */
void
dot1dBasePortTable_container_shutdown(netsnmp_container *container_ptr)
{
    DEBUGMSGTL(("verbose:dot1dBasePortTable:dot1dBasePortTable_container_shutdown","called\n"));
    
    if (NULL == container_ptr) {
        snmp_log(LOG_ERR,"bad params to dot1dBasePortTable_container_shutdown\n");
        return;
    }

} /* dot1dBasePortTable_container_shutdown */

/**
 * load initial data
 *
 * TODO:350:M: Implement dot1dBasePortTable data load
 *
 * @param container container to which items should be inserted
 *
 * @retval MFD_SUCCESS              : success.
 * @retval MFD_RESOURCE_UNAVAILABLE : Can't access data source
 * @retval MFD_ERROR                : other error.
 *
 *  This function is called to load the index(es) (and data, optionally)
 *  for the every row in the data set.
 *
 * @remark
 *  While loading the data, the only important thing is the indexes.
 *  If access to your data is cheap/fast (e.g. you have a pointer to a
 *  structure in memory), it would make sense to update the data here.
 *  If, however, the accessing the data invovles more work (e.g. parsing
 *  some other existing data, or peforming calculations to derive the data),
 *  then you can limit yourself to setting the indexes and saving any
 *  information you will need later. Then use the saved information in
 *  dot1dBasePortTable_row_prep() for populating data.
 *
 * @note
 *  If you need consistency between rows (like you want statistics
 *  for each row to be from the same time frame), you should set all
 *  data here.
 *
 */
int
dot1dBasePortTable_container_load(netsnmp_container *container)
{
    dot1dBasePortTable_rowreq_ctx *rowreq_ctx;
    size_t                 count = 0;

    /*
     * temporary storage for index values
     */
        /*
         * dot1dBasePort(1)/INTEGER32/ASN_INTEGER/long(long)//l/A/w/e/R/d/h
         */
    long   dot1dBasePort;

    char dot1dBasePortCircuit[2];
    int dot1dBasePortCircuit_len = 2; 
    int *ifIndex_lut; /* Keep ifIndex for all wri ports */
    char *tmp_c;
    int wri_i;
    struct if_nameindex *if_nidxs, *intf;

    DEBUGMSGTL(("verbose:dot1dBasePortTable:dot1dBasePortTable_container_load","called\n"));

    /* index a table with ifIndexes of interfaces in range 1..18 */
    ifIndex_lut = calloc(sizeof(int), hal_nports_local + 1);

    if_nidxs = if_nameindex();
    if ( if_nidxs != NULL ) {
        for (intf = if_nidxs; intf->if_index != 0 || intf->if_name != NULL; intf++) {
            if (!strncmp(intf->if_name, "wri", strlen("wri"))) {
                /* wri interface found */
                tmp_c = intf->if_name + strlen("wri");
                wri_i = atoi(tmp_c);
                /* save ifIndex for the found interface,
                 * +1 because ifIndex counts from 1 */
                ifIndex_lut[wri_i] = (intf - if_nidxs) + 1;
            }
        }

        if_freenameindex(if_nidxs);
    }


    for (dot1dBasePort = 1; dot1dBasePort <= hal_nports_local; dot1dBasePort++) {
        /*
         * |   |-> set indexes in new dot1dBasePortTable rowreq context.
         * data context will be set from the param (unless NULL,
         *      in which case a new data context will be allocated)
         */
        rowreq_ctx = dot1dBasePortTable_allocate_rowreq_ctx(NULL);
        if (NULL == rowreq_ctx) {
            snmp_log(LOG_ERR, "memory allocation failed\n");
            return MFD_RESOURCE_UNAVAILABLE;
        }
        if(MFD_SUCCESS != dot1dBasePortTable_indexes_set(rowreq_ctx
                               , dot1dBasePort
               )) {
            snmp_log(LOG_ERR,"error setting index while loading "
                     "dot1dBasePortTable data.\n");
            dot1dBasePortTable_release_rowreq_ctx(rowreq_ctx);
            continue;
        }

        /*
         * |   |-> populate dot1dBasePortTable data context.
         * Populate data context here. (optionally, delay until row prep)
         */

        /*
        * setup/save data for dot1dBasePortIfIndex
        * dot1dBasePortIfIndex(2)/InterfaceIndex/ASN_INTEGER/long(long)//l/A/w/e/R/d/H
        */

        rowreq_ctx->data.dot1dBasePortIfIndex = ifIndex_lut[dot1dBasePort];

        /*
        * setup/save data for dot1dBasePortCircuit
        * dot1dBasePortCircuit(3)/OBJECTID/ASN_OBJECT_ID/oid(oid)//L/A/w/e/r/d/h
        */
        /** no mapping */
        /*
        * make sure there is enough space for dot1dBasePortCircuit data
        */
        /* set the value to ZeroDotZero ({0,0}) */
        memset(dot1dBasePortCircuit, 0, dot1dBasePortCircuit_len);
        if (NULL == rowreq_ctx->data.dot1dBasePortCircuit) {
            snmp_log(LOG_ERR,"not enough space for value (dot1dBasePortCircuit)\n");
            return MFD_ERROR;
        }
        rowreq_ctx->data.dot1dBasePortCircuit_len = dot1dBasePortCircuit_len* sizeof(dot1dBasePortCircuit[0]);
        memcpy( rowreq_ctx->data.dot1dBasePortCircuit, dot1dBasePortCircuit, dot1dBasePortCircuit_len* sizeof(dot1dBasePortCircuit[0]) );

        /* dot1dBasePortDelayExceededDiscards and dot1dBasePortMtuExceededDiscards
         * are not supported */

        /*
         * insert into table container
         */
        CONTAINER_INSERT(container, rowreq_ctx);
        ++count;
    }

    free(ifIndex_lut);

    DEBUGMSGT(("verbose:dot1dBasePortTable:dot1dBasePortTable_container_load",
               "inserted %d records\n", count));

    return MFD_SUCCESS;
} /* dot1dBasePortTable_container_load */

/**
 * container clean up
 *
 * @param container container with all current items
 *
 *  This optional callback is called prior to all
 *  item's being removed from the container. If you
 *  need to do any processing before that, do it here.
 *
 * @note
 *  The MFD helper will take care of releasing all the row contexts.
 *
 */
void
dot1dBasePortTable_container_free(netsnmp_container *container)
{
    DEBUGMSGTL(("verbose:dot1dBasePortTable:dot1dBasePortTable_container_free","called\n"));

    /*
     * TODO:380:M: Free dot1dBasePortTable container data.
     */
} /* dot1dBasePortTable_container_free */

/**
 * prepare row for processing.
 *
 *  When the agent has located the row for a request, this function is
 *  called to prepare the row for processing. If you fully populated
 *  the data context during the index setup phase, you may not need to
 *  do anything.
 *
 * @param rowreq_ctx pointer to a context.
 *
 * @retval MFD_SUCCESS     : success.
 * @retval MFD_ERROR       : other error.
 */
int
dot1dBasePortTable_row_prep( dot1dBasePortTable_rowreq_ctx *rowreq_ctx)
{
    DEBUGMSGTL(("verbose:dot1dBasePortTable:dot1dBasePortTable_row_prep","called\n"));

    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * TODO:390:o: Prepare row for request.
     * If populating row data was delayed, this is the place to
     * fill in the row for this request.
     */

    return MFD_SUCCESS;
} /* dot1dBasePortTable_row_prep */

/** @} */
