/*
 * Note: this file originally auto-generated by mib2c using
 *       version $ of $ 
 *
 * $Id:$
 */
/* standard Net-SNMP includes */
#include <net-snmp/net-snmp-config.h>
#include <net-snmp/net-snmp-features.h>
#include <net-snmp/net-snmp-includes.h>
#include <net-snmp/agent/net-snmp-agent-includes.h>

/* include our parent header */
#include "dot1dStaticTable.h"

#include "wrsSnmp.h"
#include "snmp_shmem.h"

#include "dot1dStaticTable_data_access.h"

/** @ingroup interface
 * @addtogroup data_access data_access: Routines to access data
 *
 * These routines are used to locate the data used to satisfy
 * requests.
 * 
 * @{
 */
/**********************************************************************
 **********************************************************************
 ***
 *** Table dot1dStaticTable
 ***
 **********************************************************************
 **********************************************************************/
/*
 * BRIDGE-MIB::dot1dStaticTable is subid 1 of dot1dStatic.
 * Its status is Current.
 * OID: .1.3.6.1.2.1.17.5.1, length: 9
*/

/**
 * initialization for dot1dStaticTable data access
 *
 * This function is called during startup to allow you to
 * allocate any resources you need for the data table.
 *
 * @param dot1dStaticTable_reg
 *        Pointer to dot1dStaticTable_registration
 *
 * @retval MFD_SUCCESS : success.
 * @retval MFD_ERROR   : unrecoverable error.
 */
int
dot1dStaticTable_init_data(dot1dStaticTable_registration * dot1dStaticTable_reg)
{
    DEBUGMSGTL(("verbose:dot1dStaticTable:dot1dStaticTable_init_data","called\n"));

    /*
     * TODO:303:o: Initialize dot1dStaticTable data.
     */
    /*
    ***************************************************
    ***             START EXAMPLE CODE              ***
    ***---------------------------------------------***/
    /*
     * if you are the sole writer for the file, you could
     * open it here. However, as stated earlier, we are assuming
     * the worst case, which in this case means that the file is
     * written to by someone else, and might not even exist when
     * we start up. So we can't do anything here.
     */
    /*
    ***---------------------------------------------***
    ***              END  EXAMPLE CODE              ***
    ***************************************************/

    return MFD_SUCCESS;
} /* dot1dStaticTable_init_data */

/**
 * container overview
 *
 */

/**
 * container initialization
 *
 * @param container_ptr_ptr A pointer to a container pointer. If you
 *        create a custom container, use this parameter to return it
 *        to the MFD helper. If set to NULL, the MFD helper will
 *        allocate a container for you.
 * @param  cache A pointer to a cache structure. You can set the timeout
 *         and other cache flags using this pointer.
 *
 *  This function is called at startup to allow you to customize certain
 *  aspects of the access method. For the most part, it is for advanced
 *  users. The default code should suffice for most cases. If no custom
 *  container is allocated, the MFD code will create one for your.
 *
 *  This is also the place to set up cache behavior. The default, to
 *  simply set the cache timeout, will work well with the default
 *  container. If you are using a custom container, you may want to
 *  look at the cache helper documentation to see if there are any
 *  flags you want to set.
 *
 * @remark
 *  This would also be a good place to do any initialization needed
 *  for you data source. For example, opening a connection to another
 *  process that will supply the data, opening a database, etc.
 */
void
dot1dStaticTable_container_init(netsnmp_container **container_ptr_ptr,
                             netsnmp_cache *cache)
{
    DEBUGMSGTL(("verbose:dot1dStaticTable:dot1dStaticTable_container_init","called\n"));
    
    if (NULL == container_ptr_ptr) {
        snmp_log(LOG_ERR,"bad container param to dot1dStaticTable_container_init\n");
        return;
    }

    /*
     * For advanced users, you can use a custom container. If you
     * do not create one, one will be created for you.
     */
    *container_ptr_ptr = NULL;

    if (NULL == cache) {
        snmp_log(LOG_ERR,"bad cache param to dot1dStaticTable_container_init\n");
        return;
    }

    /*
     * TODO:345:A: Set up dot1dStaticTable cache properties.
     *
     * Also for advanced users, you can set parameters for the
     * cache. Do not change the magic pointer, as it is used
     * by the MFD helper. To completely disable caching, set
     * cache->enabled to 0.
     */
    cache->timeout = DOT1DSTATICTABLE_CACHE_TIMEOUT; /* seconds */
} /* dot1dStaticTable_container_init */

/**
 * container shutdown
 *
 * @param container_ptr A pointer to the container.
 *
 *  This function is called at shutdown to allow you to customize certain
 *  aspects of the access method. For the most part, it is for advanced
 *  users. The default code should suffice for most cases.
 *
 *  This function is called before dot1dStaticTable_container_free().
 *
 * @remark
 *  This would also be a good place to do any cleanup needed
 *  for you data source. For example, closing a connection to another
 *  process that supplied the data, closing a database, etc.
 */
void
dot1dStaticTable_container_shutdown(netsnmp_container *container_ptr)
{
    DEBUGMSGTL(("verbose:dot1dStaticTable:dot1dStaticTable_container_shutdown","called\n"));
    
    if (NULL == container_ptr) {
        snmp_log(LOG_ERR,"bad params to dot1dStaticTable_container_shutdown\n");
        return;
    }

} /* dot1dStaticTable_container_shutdown */

/**
 * load initial data
 *
 * TODO:350:M: Implement dot1dStaticTable data load
 * This function will also be called by the cache helper to load
 * the container again (after the container free function has been
 * called to free the previous contents).
 *
 * @param container container to which items should be inserted
 *
 * @retval MFD_SUCCESS              : success.
 * @retval MFD_RESOURCE_UNAVAILABLE : Can't access data source
 * @retval MFD_ERROR                : other error.
 *
 *  This function is called to load the index(es) (and data, optionally)
 *  for the every row in the data set.
 *
 * @remark
 *  While loading the data, the only important thing is the indexes.
 *  If access to your data is cheap/fast (e.g. you have a pointer to a
 *  structure in memory), it would make sense to update the data here.
 *  If, however, the accessing the data invovles more work (e.g. parsing
 *  some other existing data, or peforming calculations to derive the data),
 *  then you can limit yourself to setting the indexes and saving any
 *  information you will need later. Then use the saved information in
 *  dot1dStaticTable_row_prep() for populating data.
 *
 * @note
 *  If you need consistency between rows (like you want statistics
 *  for each row to be from the same time frame), you should set all
 *  data here.
 *
 */
int
dot1dStaticTable_container_load(netsnmp_container *container)
{
    dot1dStaticTable_rowreq_ctx *rowreq_ctx;
    size_t                 count = 0;

    int i;
    uint32_t port_mask;
    int htab_read_entries;
    struct rtu_filtering_entry rtu_htab_local[RTU_BUCKETS * HTAB_ENTRIES];
    int dot1dStaticReceivePort;

    DEBUGMSGTL(("verbose:dot1qTpFdbTable:dot1qTpFdbTable_container_load","called\n"));

    /* read filter entires from shm to local memory for data consistency */
    if (shmem_rtu_read_htab(rtu_htab_local, &htab_read_entries)) {
	DEBUGMSGTL(("verbose:dot1qTpFdbTable:dot1qTpFdbTable_container_load",
		    "Too many retries while reading htab entries from RTUd shmem\n"));
	return MFD_RESOURCE_UNAVAILABLE;
    }
	
    qsort(rtu_htab_local, htab_read_entries,
          sizeof(struct rtu_filtering_entry), cmp_rtu_entries_fid_mac);

    for (i = 0; i < htab_read_entries; i++) {
	dot1dStaticReceivePort = 1;
	/* skip invalid entires */
	if (!rtu_htab_local[i].valid)
	    continue;

	/* skip if destination is only a CPU */
	if (rtu_htab_local[i].port_mask_dst == 1 << hal_nports_local) {
	    continue;
	}

	/* skip non static entries */
	if (rtu_htab_local[i].dynamic != RTU_ENTRY_TYPE_STATIC) {
	    continue;
	}

	port_mask = RTU_PMASK_MAX(hal_nports_local);

	if ((rtu_htab_local[i].port_mask_src & port_mask) == port_mask) {
	    /* all ports in the mask, use 0 as stated in the mib */
	    dot1dStaticReceivePort = 0;
	} else {
	    /* ignore bits not representing ports */
	    port_mask = rtu_htab_local[i].port_mask_src & port_mask;
	}

	while(1){
	    if (dot1dStaticReceivePort != 0) {
		while (!(port_mask & 1)&& port_mask){
		    /* skip ports not in mask */
		    dot1dStaticReceivePort++;
		    port_mask >>= 1;
		}
		if (!port_mask) {
		    /* no more ports */
		    break;
		}
	    }

	    /*
	    * |-> set indexes in new dot1dStaticTable rowreq context.
	    * data context will be set from the param (unless NULL,
	    *      in which case a new data context will be allocated)
	    */
	    rowreq_ctx = dot1dStaticTable_allocate_rowreq_ctx(NULL);
	    if (NULL == rowreq_ctx) {
		snmp_log(LOG_ERR, "memory allocation failed\n");
		return MFD_RESOURCE_UNAVAILABLE;
	    }
	    if(MFD_SUCCESS != dot1dStaticTable_indexes_set(rowreq_ctx
				, (char *)rtu_htab_local[i].mac, ETH_ALEN
				, dot1dStaticReceivePort
		)) {
		snmp_log(LOG_ERR,"error setting index while loading "
			"dot1dStaticTable data.\n");
		dot1dStaticTable_release_rowreq_ctx(rowreq_ctx);
		continue;
	    }

	    /*
	    * setup/save data for dot1dStaticAllowedToGoTo
	    * dot1dStaticAllowedToGoTo(3)/OCTETSTR/ASN_OCTET_STR/char(char)//L/A/W/e/R/d/h
	    */
	    /*
	    * TODO:246:r: |-> Define dot1dStaticAllowedToGoTo mapping.
	    * Map values between raw/native values and MIB values
	    *
	    * if(MFD_SUCCESS !=
	    *    dot1dStaticAllowedToGoTo_map(&rowreq_ctx->data.dot1dStaticAllowedToGoTo, &rowreq_ctx->data.dot1dStaticAllowedToGoTo_len,
	    *                dot1dStaticAllowedToGoTo, dot1dStaticAllowedToGoTo_len, 0)) {
	    *    return MFD_ERROR;
	    * }
	    */
	    /*
	    * make sure there is enough space for dot1dStaticAllowedToGoTo data
	    */
	    if (NULL == rowreq_ctx->data.dot1dStaticAllowedToGoTo) {
	        snmp_log(LOG_ERR,"not enough space for value (dot1dStaticAllowedToGoTo)\n");
	        return MFD_ERROR;
	    }
	    convert_portmask_to_snmp_bitmask(hal_nports_local, rtu_htab_local[i].port_mask_dst & RTU_PMASK_MAX(hal_nports_local),
					     rowreq_ctx->data.dot1dStaticAllowedToGoTo, &rowreq_ctx->data.dot1dStaticAllowedToGoTo_len);
	    /*
	    * setup/save data for dot1dStaticStatus
	    * dot1dStaticStatus(4)/INTEGER/ASN_INTEGER/long(u_long)//l/A/W/E/r/d/h
	    */
	    /*
	    * |-> Define dot1dStaticStatus mapping.
	    * Map values between raw/native values and MIB values
	    *
	    * enums usually need mapping.
	    */
	    if(MFD_SUCCESS !=
	    dot1dStaticStatus_map(&rowreq_ctx->data.dot1dStaticStatus, rtu_htab_local[i].dynamic )) {
		return MFD_ERROR;
	    }

	    /*
	    * insert into table container
	    */
	    CONTAINER_INSERT(container, rowreq_ctx);
	    ++count;

	    if (dot1dStaticReceivePort == 0) {
		/* only one entry with dot1dStaticReceivePort == 0 (all ports) as stated in the mib */
		break;
	    }
	    /* go to next port */
	    dot1dStaticReceivePort++;
	    port_mask >>= 1;

	}
    }

    DEBUGMSGT(("verbose:dot1dStaticTable:dot1dStaticTable_container_load",
               "inserted %d records\n", count));

    return MFD_SUCCESS;
} /* dot1dStaticTable_container_load */

/**
 * container clean up
 *
 * @param container container with all current items
 *
 *  This optional callback is called prior to all
 *  item's being removed from the container. If you
 *  need to do any processing before that, do it here.
 *
 * @note
 *  The MFD helper will take care of releasing all the row contexts.
 *
 */
void
dot1dStaticTable_container_free(netsnmp_container *container)
{
    DEBUGMSGTL(("verbose:dot1dStaticTable:dot1dStaticTable_container_free","called\n"));

    /*
     * TODO:380:M: Free dot1dStaticTable container data.
     */
} /* dot1dStaticTable_container_free */

/**
 * prepare row for processing.
 *
 *  When the agent has located the row for a request, this function is
 *  called to prepare the row for processing. If you fully populated
 *  the data context during the index setup phase, you may not need to
 *  do anything.
 *
 * @param rowreq_ctx pointer to a context.
 *
 * @retval MFD_SUCCESS     : success.
 * @retval MFD_ERROR       : other error.
 */
int
dot1dStaticTable_row_prep( dot1dStaticTable_rowreq_ctx *rowreq_ctx)
{
    DEBUGMSGTL(("verbose:dot1dStaticTable:dot1dStaticTable_row_prep","called\n"));

    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * TODO:390:o: Prepare row for request.
     * If populating row data was delayed, this is the place to
     * fill in the row for this request.
     */

    return MFD_SUCCESS;
} /* dot1dStaticTable_row_prep */

/** @} */
