/*
 * Note: this file originally auto-generated by mib2c using
 *       version $ of $ 
 *
 * $Id:$
 */
/* standard Net-SNMP includes */
#include <net-snmp/net-snmp-config.h>
#include <net-snmp/net-snmp-features.h>
#include <net-snmp/net-snmp-includes.h>
#include <net-snmp/agent/net-snmp-agent-includes.h>

/* include our parent header */
#include "dot1qPortVlanTable.h"

#include "wrsSnmp.h"
#include "snmp_shmem.h"

#include "dot1qPortVlanTable_data_access.h"

/** @ingroup interface
 * @addtogroup data_access data_access: Routines to access data
 *
 * These routines are used to locate the data used to satisfy
 * requests.
 * 
 * @{
 */
/**********************************************************************
 **********************************************************************
 ***
 *** Table dot1qPortVlanTable
 ***
 **********************************************************************
 **********************************************************************/
/*
 * Q-BRIDGE-MIB::dot1qPortVlanTable is subid 5 of dot1qVlan.
 * Its status is Current.
 * OID: .1.3.6.1.2.1.17.7.1.4.5, length: 11
*/

/**
 * initialization for dot1qPortVlanTable data access
 *
 * This function is called during startup to allow you to
 * allocate any resources you need for the data table.
 *
 * @param dot1qPortVlanTable_reg
 *        Pointer to dot1qPortVlanTable_registration
 *
 * @retval MFD_SUCCESS : success.
 * @retval MFD_ERROR   : unrecoverable error.
 */
int
dot1qPortVlanTable_init_data(dot1qPortVlanTable_registration * dot1qPortVlanTable_reg)
{
    DEBUGMSGTL(("verbose:dot1qPortVlanTable:dot1qPortVlanTable_init_data","called\n"));

    /*
     * TODO:303:o: Initialize dot1qPortVlanTable data.
     */
    /*
    ***************************************************
    ***             START EXAMPLE CODE              ***
    ***---------------------------------------------***/
    /*
     * if you are the sole writer for the file, you could
     * open it here. However, as stated earlier, we are assuming
     * the worst case, which in this case means that the file is
     * written to by someone else, and might not even exist when
     * we start up. So we can't do anything here.
     */
    /*
    ***---------------------------------------------***
    ***              END  EXAMPLE CODE              ***
    ***************************************************/

    return MFD_SUCCESS;
} /* dot1qPortVlanTable_init_data */

/**
 * container overview
 *
 */

/**
 * container initialization
 *
 * @param container_ptr_ptr A pointer to a container pointer. If you
 *        create a custom container, use this parameter to return it
 *        to the MFD helper. If set to NULL, the MFD helper will
 *        allocate a container for you.
 * @param  cache A pointer to a cache structure. You can set the timeout
 *         and other cache flags using this pointer.
 *
 *  This function is called at startup to allow you to customize certain
 *  aspects of the access method. For the most part, it is for advanced
 *  users. The default code should suffice for most cases. If no custom
 *  container is allocated, the MFD code will create one for your.
 *
 *  This is also the place to set up cache behavior. The default, to
 *  simply set the cache timeout, will work well with the default
 *  container. If you are using a custom container, you may want to
 *  look at the cache helper documentation to see if there are any
 *  flags you want to set.
 *
 * @remark
 *  This would also be a good place to do any initialization needed
 *  for you data source. For example, opening a connection to another
 *  process that will supply the data, opening a database, etc.
 */
void
dot1qPortVlanTable_container_init(netsnmp_container **container_ptr_ptr,
                             netsnmp_cache *cache)
{
    DEBUGMSGTL(("verbose:dot1qPortVlanTable:dot1qPortVlanTable_container_init","called\n"));
    
    if (NULL == container_ptr_ptr) {
        snmp_log(LOG_ERR,"bad container param to dot1qPortVlanTable_container_init\n");
        return;
    }

    /*
     * For advanced users, you can use a custom container. If you
     * do not create one, one will be created for you.
     */
    *container_ptr_ptr = NULL;

    if (NULL == cache) {
        snmp_log(LOG_ERR,"bad cache param to dot1qPortVlanTable_container_init\n");
        return;
    }

    /*
     * TODO:345:A: Set up dot1qPortVlanTable cache properties.
     *
     * Also for advanced users, you can set parameters for the
     * cache. Do not change the magic pointer, as it is used
     * by the MFD helper. To completely disable caching, set
     * cache->enabled to 0.
     */
    cache->timeout = DOT1QPORTVLANTABLE_CACHE_TIMEOUT; /* seconds */
} /* dot1qPortVlanTable_container_init */

/**
 * container shutdown
 *
 * @param container_ptr A pointer to the container.
 *
 *  This function is called at shutdown to allow you to customize certain
 *  aspects of the access method. For the most part, it is for advanced
 *  users. The default code should suffice for most cases.
 *
 *  This function is called before dot1qPortVlanTable_container_free().
 *
 * @remark
 *  This would also be a good place to do any cleanup needed
 *  for you data source. For example, closing a connection to another
 *  process that supplied the data, closing a database, etc.
 */
void
dot1qPortVlanTable_container_shutdown(netsnmp_container *container_ptr)
{
    DEBUGMSGTL(("verbose:dot1qPortVlanTable:dot1qPortVlanTable_container_shutdown","called\n"));
    
    if (NULL == container_ptr) {
        snmp_log(LOG_ERR,"bad params to dot1qPortVlanTable_container_shutdown\n");
        return;
    }

} /* dot1qPortVlanTable_container_shutdown */

/**
 * load initial data
 *
 * TODO:350:M: Implement dot1qPortVlanTable data load
 * This function will also be called by the cache helper to load
 * the container again (after the container free function has been
 * called to free the previous contents).
 *
 * @param container container to which items should be inserted
 *
 * @retval MFD_SUCCESS              : success.
 * @retval MFD_RESOURCE_UNAVAILABLE : Can't access data source
 * @retval MFD_ERROR                : other error.
 *
 *  This function is called to load the index(es) (and data, optionally)
 *  for the every row in the data set.
 *
 * @remark
 *  While loading the data, the only important thing is the indexes.
 *  If access to your data is cheap/fast (e.g. you have a pointer to a
 *  structure in memory), it would make sense to update the data here.
 *  If, however, the accessing the data invovles more work (e.g. parsing
 *  some other existing data, or peforming calculations to derive the data),
 *  then you can limit yourself to setting the indexes and saving any
 *  information you will need later. Then use the saved information in
 *  dot1qPortVlanTable_row_prep() for populating data.
 *
 * @note
 *  If you need consistency between rows (like you want statistics
 *  for each row to be from the same time frame), you should set all
 *  data here.
 *
 */
int
dot1qPortVlanTable_container_load(netsnmp_container *container)
{
    dot1qPortVlanTable_rowreq_ctx *rowreq_ctx;
    size_t                 count = 0;
    int port_i;

    struct rtu_port_entry ports_tab_local[HAL_MAX_PORTS];
    int rtu_nports_local;

    DEBUGMSGTL(("verbose:dot1qPortVlanTable:dot1qPortVlanTable_container_load","called\n"));

    if (shmem_rtu_read_ports(ports_tab_local, &rtu_nports_local)) {
	snmp_log(LOG_ERR, "unable to get ports info from RTU\n");
	return MFD_RESOURCE_UNAVAILABLE;
    }

    /*
     * Load/update data in the dot1qPortVlanTable container.
     * loop over your dot1qPortVlanTable data, allocate a rowreq context,
     * set the index(es) and data then insert into the container.
     */
    for (port_i = 0; port_i < rtu_nports_local; port_i++){

        /*
         * |-> set indexes in new dot1qPortVlanTable rowreq context.
         * data context will be set from the param (unless NULL,
         *      in which case a new data context will be allocated)
         */
        rowreq_ctx = dot1qPortVlanTable_allocate_rowreq_ctx(NULL);
        if (NULL == rowreq_ctx) {
            snmp_log(LOG_ERR, "memory allocation failed\n");
            return MFD_RESOURCE_UNAVAILABLE;
        }
        if(MFD_SUCCESS != dot1qPortVlanTable_indexes_set(rowreq_ctx, port_i + 1)) {
            snmp_log(LOG_ERR,"error setting index while loading "
                     "dot1qPortVlanTable data.\n");
            dot1qPortVlanTable_release_rowreq_ctx(rowreq_ctx);
            continue;
        }

        /*
         * TODO:352:r: |   |-> populate dot1qPortVlanTable data context.
         * Populate data context here. (optionally, delay until row prep)
         */
	/*
	* setup/save data for dot1qPvid
	* dot1qPvid(1)/VlanIndex/ASN_UNSIGNED/u_long(u_long)//l/A/W/e/r/D/H
	*/
	rowreq_ctx->data.dot1qPvid = ports_tab_local[port_i].pvid;
	
	/*
	* setup/save data for dot1qPortAcceptableFrameTypes
	* dot1qPortAcceptableFrameTypes(2)/INTEGER/ASN_INTEGER/long(u_long)//l/A/W/E/r/D/h
	*/
	/*
	* |-> Define dot1qPortAcceptableFrameTypes mapping.
	* Map values between raw/native values and MIB values
	*/
	if(MFD_SUCCESS !=
	dot1qPortAcceptableFrameTypes_map(&rowreq_ctx->data.dot1qPortAcceptableFrameTypes, ports_tab_local[port_i].qmode )) {
	    return MFD_ERROR;
	}
	
	/*
	* setup/save data for dot1qPortIngressFiltering
	* dot1qPortIngressFiltering(3)/TruthValue/ASN_INTEGER/long(u_long)//l/A/W/E/r/D/h
	*/
	/*
	* |-> Define dot1qPortIngressFiltering mapping.
	*/
	rowreq_ctx->data.dot1qPortIngressFiltering = TRUTHVALUE_FALSE;
	
	/*
	* setup/save data for dot1qPortGvrpStatus
	* dot1qPortGvrpStatus(4)/EnabledStatus/ASN_INTEGER/long(u_long)//l/A/W/E/r/D/h
	*/
	/*
	* hardcode dot1qPortGvrpStatus as disabled(2)
	*/
	rowreq_ctx->data.dot1qPortGvrpStatus = ENABLEDSTATUS_DISABLED;
	
	/*
	* setup/save data for dot1qPortGvrpFailedRegistrations
	* dot1qPortGvrpFailedRegistrations(5)/COUNTER/ASN_COUNTER/u_long(u_long)//l/A/w/e/r/d/h
	*/
	/*
	* Hardcode to 0.
	*/
	rowreq_ctx->data.dot1qPortGvrpFailedRegistrations = 0;
	
	/*
	* setup/save data for dot1qPortGvrpLastPduOrigin
	* dot1qPortGvrpLastPduOrigin(6)/MacAddress/ASN_OCTET_STR/char(char)//L/A/w/e/R/d/H
	*/

	if (NULL == rowreq_ctx->data.dot1qPortGvrpLastPduOrigin) {
	    snmp_log(LOG_ERR,"not enough space for value (dot1qPortGvrpLastPduOrigin)\n");
	    return MFD_ERROR;
	}
	rowreq_ctx->data.dot1qPortGvrpLastPduOrigin_len = ETH_ALEN;
	memset(rowreq_ctx->data.dot1qPortGvrpLastPduOrigin, 0, ETH_ALEN);

	/*
	* setup/save data for dot1qPortRestrictedVlanRegistration
	* dot1qPortRestrictedVlanRegistration(7)/TruthValue/ASN_INTEGER/long(u_long)//l/A/W/E/r/D/h
	*/
	/*
	* hardcode dot1qPortRestrictedVlanRegistration as false(2)
	*/
	rowreq_ctx->data.dot1qPortRestrictedVlanRegistration = TRUTHVALUE_FALSE;

        /*
         * insert into table container
         */
        CONTAINER_INSERT(container, rowreq_ctx);
        ++count;
    }

    DEBUGMSGT(("verbose:dot1qPortVlanTable:dot1qPortVlanTable_container_load",
               "inserted %d records\n", count));

    return MFD_SUCCESS;
} /* dot1qPortVlanTable_container_load */

/**
 * container clean up
 *
 * @param container container with all current items
 *
 *  This optional callback is called prior to all
 *  item's being removed from the container. If you
 *  need to do any processing before that, do it here.
 *
 * @note
 *  The MFD helper will take care of releasing all the row contexts.
 *
 */
void
dot1qPortVlanTable_container_free(netsnmp_container *container)
{
    DEBUGMSGTL(("verbose:dot1qPortVlanTable:dot1qPortVlanTable_container_free","called\n"));

    /*
     * TODO:380:M: Free dot1qPortVlanTable container data.
     */
} /* dot1qPortVlanTable_container_free */

/**
 * prepare row for processing.
 *
 *  When the agent has located the row for a request, this function is
 *  called to prepare the row for processing. If you fully populated
 *  the data context during the index setup phase, you may not need to
 *  do anything.
 *
 * @param rowreq_ctx pointer to a context.
 *
 * @retval MFD_SUCCESS     : success.
 * @retval MFD_ERROR       : other error.
 */
int
dot1qPortVlanTable_row_prep( dot1qPortVlanTable_rowreq_ctx *rowreq_ctx)
{
    DEBUGMSGTL(("verbose:dot1qPortVlanTable:dot1qPortVlanTable_row_prep","called\n"));

    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * TODO:390:o: Prepare row for request.
     * If populating row data was delayed, this is the place to
     * fill in the row for this request.
     */

    return MFD_SUCCESS;
} /* dot1qPortVlanTable_row_prep */

/** @} */
