/*
 * Note: this file originally auto-generated by mib2c using
 *       version $ of $ 
 *
 * $Id:$
 */
/* standard Net-SNMP includes */
#include <net-snmp/net-snmp-config.h>
#include <net-snmp/net-snmp-features.h>
#include <net-snmp/net-snmp-includes.h>
#include <net-snmp/agent/net-snmp-agent-includes.h>

#include "wrsSnmp.h"
#include "snmp_shmem.h"

/* include our parent header */
#include "dot1qVlanCurrentTable.h"


#include "dot1qVlanCurrentTable_data_access.h"

/** @ingroup interface
 * @addtogroup data_access data_access: Routines to access data
 *
 * These routines are used to locate the data used to satisfy
 * requests.
 * 
 * @{
 */
/**********************************************************************
 **********************************************************************
 ***
 *** Table dot1qVlanCurrentTable
 ***
 **********************************************************************
 **********************************************************************/
/*
 * Q-BRIDGE-MIB::dot1qVlanCurrentTable is subid 2 of dot1qVlan.
 * Its status is Current.
 * OID: .1.3.6.1.2.1.17.7.1.4.2, length: 11
*/

/**
 * initialization for dot1qVlanCurrentTable data access
 *
 * This function is called during startup to allow you to
 * allocate any resources you need for the data table.
 *
 * @param dot1qVlanCurrentTable_reg
 *        Pointer to dot1qVlanCurrentTable_registration
 *
 * @retval MFD_SUCCESS : success.
 * @retval MFD_ERROR   : unrecoverable error.
 */
int
dot1qVlanCurrentTable_init_data(dot1qVlanCurrentTable_registration * dot1qVlanCurrentTable_reg)
{
    DEBUGMSGTL(("verbose:dot1qVlanCurrentTable:dot1qVlanCurrentTable_init_data","called\n"));

    /*
     * TODO:303:o: Initialize dot1qVlanCurrentTable data.
     */
    /*
    ***************************************************
    ***             START EXAMPLE CODE              ***
    ***---------------------------------------------***/
    /*
     * if you are the sole writer for the file, you could
     * open it here. However, as stated earlier, we are assuming
     * the worst case, which in this case means that the file is
     * written to by someone else, and might not even exist when
     * we start up. So we can't do anything here.
     */
    /*
    ***---------------------------------------------***
    ***              END  EXAMPLE CODE              ***
    ***************************************************/

    return MFD_SUCCESS;
} /* dot1qVlanCurrentTable_init_data */

/**
 * container overview
 *
 */

/**
 * container initialization
 *
 * @param container_ptr_ptr A pointer to a container pointer. If you
 *        create a custom container, use this parameter to return it
 *        to the MFD helper. If set to NULL, the MFD helper will
 *        allocate a container for you.
 * @param  cache A pointer to a cache structure. You can set the timeout
 *         and other cache flags using this pointer.
 *
 *  This function is called at startup to allow you to customize certain
 *  aspects of the access method. For the most part, it is for advanced
 *  users. The default code should suffice for most cases. If no custom
 *  container is allocated, the MFD code will create one for your.
 *
 *  This is also the place to set up cache behavior. The default, to
 *  simply set the cache timeout, will work well with the default
 *  container. If you are using a custom container, you may want to
 *  look at the cache helper documentation to see if there are any
 *  flags you want to set.
 *
 * @remark
 *  This would also be a good place to do any initialization needed
 *  for you data source. For example, opening a connection to another
 *  process that will supply the data, opening a database, etc.
 */
void
dot1qVlanCurrentTable_container_init(netsnmp_container **container_ptr_ptr,
                             netsnmp_cache *cache)
{
    DEBUGMSGTL(("verbose:dot1qVlanCurrentTable:dot1qVlanCurrentTable_container_init","called\n"));
    
    if (NULL == container_ptr_ptr) {
        snmp_log(LOG_ERR,"bad container param to dot1qVlanCurrentTable_container_init\n");
        return;
    }

    /*
     * For advanced users, you can use a custom container. If you
     * do not create one, one will be created for you.
     */
    *container_ptr_ptr = NULL;

    if (NULL == cache) {
        snmp_log(LOG_ERR,"bad cache param to dot1qVlanCurrentTable_container_init\n");
        return;
    }

    /*
     * TODO:345:A: Set up dot1qVlanCurrentTable cache properties.
     *
     * Also for advanced users, you can set parameters for the
     * cache. Do not change the magic pointer, as it is used
     * by the MFD helper. To completely disable caching, set
     * cache->enabled to 0.
     */
    cache->timeout = DOT1QVLANCURRENTTABLE_CACHE_TIMEOUT; /* seconds */
} /* dot1qVlanCurrentTable_container_init */

/**
 * container shutdown
 *
 * @param container_ptr A pointer to the container.
 *
 *  This function is called at shutdown to allow you to customize certain
 *  aspects of the access method. For the most part, it is for advanced
 *  users. The default code should suffice for most cases.
 *
 *  This function is called before dot1qVlanCurrentTable_container_free().
 *
 * @remark
 *  This would also be a good place to do any cleanup needed
 *  for you data source. For example, closing a connection to another
 *  process that supplied the data, closing a database, etc.
 */
void
dot1qVlanCurrentTable_container_shutdown(netsnmp_container *container_ptr)
{
    DEBUGMSGTL(("verbose:dot1qVlanCurrentTable:dot1qVlanCurrentTable_container_shutdown","called\n"));
    
    if (NULL == container_ptr) {
        snmp_log(LOG_ERR,"bad params to dot1qVlanCurrentTable_container_shutdown\n");
        return;
    }

} /* dot1qVlanCurrentTable_container_shutdown */

/**
 * load initial data
 *
 * TODO:350:M: Implement dot1qVlanCurrentTable data load
 * This function will also be called by the cache helper to load
 * the container again (after the container free function has been
 * called to free the previous contents).
 *
 * @param container container to which items should be inserted
 *
 * @retval MFD_SUCCESS              : success.
 * @retval MFD_RESOURCE_UNAVAILABLE : Can't access data source
 * @retval MFD_ERROR                : other error.
 *
 *  This function is called to load the index(es) (and data, optionally)
 *  for the every row in the data set.
 *
 * @remark
 *  While loading the data, the only important thing is the indexes.
 *  If access to your data is cheap/fast (e.g. you have a pointer to a
 *  structure in memory), it would make sense to update the data here.
 *  If, however, the accessing the data invovles more work (e.g. parsing
 *  some other existing data, or peforming calculations to derive the data),
 *  then you can limit yourself to setting the indexes and saving any
 *  information you will need later. Then use the saved information in
 *  dot1qVlanCurrentTable_row_prep() for populating data.
 *
 * @note
 *  If you need consistency between rows (like you want statistics
 *  for each row to be from the same time frame), you should set all
 *  data here.
 *
 */
int
dot1qVlanCurrentTable_container_load(netsnmp_container *container)
{
    dot1qVlanCurrentTable_rowreq_ctx *rowreq_ctx;
    size_t                 count = 0;

    struct rtu_vlan_table_entry vlan_tab_local[NUM_VLANS];
    struct rtu_port_entry ports_tab_local[HAL_MAX_PORTS];
    int rtu_nports_local;
    uint32_t untag_mask = 0;

    int vlan_i;
    int port_i;
    u_long dot1qVlanTimeMark;
    uint64_t agent_uptime_hs; /* in 100th of second */
    uint64_t monotonic_now_hs; /* in 100th of second */
    uint64_t creation_time_hs; /* in 100th of second */
    uint64_t netsnmp_start_ts_monotonic_hs; /* in 100th of second */
    struct timeval monotonic_now;

    DEBUGMSGTL(("verbose:dot1qVlanCurrentTable:dot1qVlanCurrentTable_container_load","called\n"));

    if (0 != shmem_rtu_read_vlans(vlan_tab_local)) {
	snmp_log(LOG_ERR, "unable to get vlans info from RTU\n");
	return MFD_RESOURCE_UNAVAILABLE;
    }

    if (shmem_rtu_read_ports(ports_tab_local, &rtu_nports_local)) {
	snmp_log(LOG_ERR, "unable to get ports info from RTU\n");
	return MFD_RESOURCE_UNAVAILABLE;
    }

    /* build a mask of untagged ports (needed for dot1qVlanCurrentUntaggedPorts) */
    for (port_i = rtu_nports_local - 1; port_i >= 0; port_i--){
	untag_mask <<= 1;
	untag_mask |= ports_tab_local[port_i].untag & 1;
    }

    netsnmp_get_monotonic_clock(&monotonic_now);
    /* Unfortunately netsnmp_get_agent_uptime also calls netsnmp_get_monotonic_clock,
     * but there is no function to get the timestamp of a monotonic clock when
     * the agest was started */
    agent_uptime_hs = netsnmp_get_agent_uptime();
    monotonic_now_hs = monotonic_now.tv_sec * (uint64_t)100 + monotonic_now.tv_usec / 10000;
    netsnmp_start_ts_monotonic_hs = monotonic_now_hs - agent_uptime_hs;

    /*
     * |-> Load/update data in the dot1qVlanCurrentTable container.
     * loop over your dot1qVlanCurrentTable data, allocate a rowreq context,
     * set the index(es) [and data, optionally] and insert into
     * the container.
     */
    for (vlan_i = 0; vlan_i < NUM_VLANS; vlan_i++) {
	/* skip empty entires */
	if ((vlan_tab_local[vlan_i].drop != 0) && (vlan_tab_local[vlan_i].port_mask == 0x0)) {
	    continue;
	}
	

	creation_time_hs = vlan_tab_local[vlan_i].creation_time.tv_sec * (uint64_t)100
			   + vlan_tab_local[vlan_i].creation_time.tv_usec / 10000;

	if (netsnmp_start_ts_monotonic_hs > creation_time_hs) {
	    /* entry has alredy existed when SNMP agent started */
	    dot1qVlanTimeMark = 0;
	} else {
	    dot1qVlanTimeMark = creation_time_hs - netsnmp_start_ts_monotonic_hs; 
	}

	/*
         * |-> set indexes in new dot1qVlanCurrentTable rowreq context.
         * data context will be set from the param (unless NULL,
         *      in which case a new data context will be allocated)
         */
        rowreq_ctx = dot1qVlanCurrentTable_allocate_rowreq_ctx(NULL);
        if (NULL == rowreq_ctx) {
            snmp_log(LOG_ERR, "memory allocation failed\n");
            return MFD_RESOURCE_UNAVAILABLE;
        }
        if(MFD_SUCCESS != dot1qVlanCurrentTable_indexes_set(rowreq_ctx
                               , dot1qVlanTimeMark
                               , vlan_i
               )) {
            snmp_log(LOG_ERR,"error setting index while loading "
                     "dot1qVlanCurrentTable data.\n");
            dot1qVlanCurrentTable_release_rowreq_ctx(rowreq_ctx);
            continue;
        }

        /*
         * |-> populate dot1qVlanCurrentTable data context.
         * Populate data context here. (optionally, delay until row prep)
         */
	/*
	* setup/save data for dot1qVlanFdbId
	* dot1qVlanFdbId(3)/UNSIGNED32/ASN_UNSIGNED/u_long(u_long)//l/A/w/e/r/d/h
	*/
	rowreq_ctx->data.dot1qVlanFdbId = vlan_tab_local[vlan_i].fid;
	
	/*
	* setup/save data for dot1qVlanCurrentEgressPorts
	* dot1qVlanCurrentEgressPorts(4)/PortList/ASN_OCTET_STR/char(char)//L/A/w/e/r/d/h
	*/
	if (NULL == rowreq_ctx->data.dot1qVlanCurrentEgressPorts) {
	    snmp_log(LOG_ERR,"not enough space for value (dot1qVlanCurrentEgressPorts)\n");
	    dot1qVlanCurrentTable_release_rowreq_ctx(rowreq_ctx);
	    return MFD_ERROR;
	}
	convert_portmask_to_snmp_bitmask(hal_nports_local,
					 vlan_tab_local[vlan_i].port_mask & RTU_PMASK_MAX(rtu_nports_local),
					 rowreq_ctx->data.dot1qVlanCurrentEgressPorts,
					 &rowreq_ctx->data.dot1qVlanCurrentEgressPorts_len);
	
	/*
	* setup/save data for dot1qVlanCurrentUntaggedPorts
	* dot1qVlanCurrentUntaggedPorts(5)/PortList/ASN_OCTET_STR/char(char)//L/A/w/e/r/d/h
	*/
	if (NULL == rowreq_ctx->data.dot1qVlanCurrentUntaggedPorts) {
	    snmp_log(LOG_ERR,"not enough space for value (dot1qVlanCurrentUntaggedPorts)\n");
	    dot1qVlanCurrentTable_release_rowreq_ctx(rowreq_ctx);
	    return MFD_ERROR;
	}
	convert_portmask_to_snmp_bitmask(hal_nports_local,
					 vlan_tab_local[vlan_i].port_mask & untag_mask,
					 rowreq_ctx->data.dot1qVlanCurrentUntaggedPorts,
					 &rowreq_ctx->data.dot1qVlanCurrentUntaggedPorts_len);
	
	/*
	* setup/save data for dot1qVlanStatus
	* dot1qVlanStatus(6)/INTEGER/ASN_INTEGER/long(u_long)//l/A/w/E/r/d/h
	*/
	/*
	* Hardcode to Permanent(2)
	*/
	rowreq_ctx->data.dot1qVlanStatus = DOT1QVLANSTATUS_PERMANENT;
	
	/*
	* setup/save data for dot1qVlanCreationTime
	* dot1qVlanCreationTime(7)/TICKS/ASN_TIMETICKS/u_long(u_long)//l/A/w/e/r/d/h
	*/

	rowreq_ctx->data.dot1qVlanCreationTime = dot1qVlanTimeMark;


        /*
         * insert into table container
         */
        CONTAINER_INSERT(container, rowreq_ctx);
        ++count;
    }

    DEBUGMSGT(("verbose:dot1qVlanCurrentTable:dot1qVlanCurrentTable_container_load",
               "inserted %d records\n", count));

    return MFD_SUCCESS;
} /* dot1qVlanCurrentTable_container_load */

/**
 * container clean up
 *
 * @param container container with all current items
 *
 *  This optional callback is called prior to all
 *  item's being removed from the container. If you
 *  need to do any processing before that, do it here.
 *
 * @note
 *  The MFD helper will take care of releasing all the row contexts.
 *
 */
void
dot1qVlanCurrentTable_container_free(netsnmp_container *container)
{
    DEBUGMSGTL(("verbose:dot1qVlanCurrentTable:dot1qVlanCurrentTable_container_free","called\n"));

    /*
     * TODO:380:M: Free dot1qVlanCurrentTable container data.
     */
} /* dot1qVlanCurrentTable_container_free */

/**
 * prepare row for processing.
 *
 *  When the agent has located the row for a request, this function is
 *  called to prepare the row for processing. If you fully populated
 *  the data context during the index setup phase, you may not need to
 *  do anything.
 *
 * @param rowreq_ctx pointer to a context.
 *
 * @retval MFD_SUCCESS     : success.
 * @retval MFD_ERROR       : other error.
 */
int
dot1qVlanCurrentTable_row_prep( dot1qVlanCurrentTable_rowreq_ctx *rowreq_ctx)
{
    DEBUGMSGTL(("verbose:dot1qVlanCurrentTable:dot1qVlanCurrentTable_row_prep","called\n"));

    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * TODO:390:o: Prepare row for request.
     * If populating row data was delayed, this is the place to
     * fill in the row for this request.
     */

    return MFD_SUCCESS;
} /* dot1qVlanCurrentTable_row_prep */

/** @} */
